package org.apache.bcel.verifier;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import org.apache.bcel.verifier.Verifier;
import org.apache.bcel.verifier.VerifierFactoryObserver;

public class VerifierFactory {
  private static final Map<String, Verifier> MAP = new HashMap<>();
  
  private static final List<VerifierFactoryObserver> OBSVERVERS = new Vector<>();
  
  public static void attach(VerifierFactoryObserver o) {
    OBSVERVERS.add(o);
  }
  
  static void clear() {
    MAP.clear();
    OBSVERVERS.clear();
  }
  
  public static void detach(VerifierFactoryObserver o) {
    OBSVERVERS.remove(o);
  }
  
  public static Verifier getVerifier(String fullyQualifiedClassName) {
    return MAP.computeIfAbsent(fullyQualifiedClassName, k -> {
          Verifier v = new Verifier(k);
          notify(k);
          return v;
        });
  }
  
  public static Verifier[] getVerifiers() {
    return (Verifier[])MAP.values().toArray((Object[])Verifier.EMPTY_ARRAY);
  }
  
  private static void notify(String fullyQualifiedClassName) {
    OBSVERVERS.forEach(vfo -> vfo.update(fullyQualifiedClassName));
  }
}
